//----------------------------------------------------------------------------
// Nntpcli.hpp - bcbdcc32 generated hdr (DO NOT EDIT) rev: 0
// From: Nntpcli.pas
//----------------------------------------------------------------------------
#ifndef NntpcliHPP
#define NntpcliHPP
//----------------------------------------------------------------------------
#include <WSocket.hpp>
#include <WinSock.hpp>
#include <Forms.hpp>
#include <Classes.hpp>
#include <Messages.hpp>
#include <SysUtils.hpp>
#include <Windows.hpp>
#include <System.hpp>
namespace Nntpcli
{
//-- type declarations -------------------------------------------------------
typedef void __fastcall (__closure *TNntpDisplay)(System::TObject* Sender, char * Msg, int Len);

enum TNntpState { nntpNotConnected, nntpDnsLookup, nntpWaitingBanner, nntpReady, nntpWaitingResponse 
	};

enum TNntpRequest { nntpGroup, nntpList, nntpConnect, nntpPost, nntpHelp, nntpNewGroups, nntpNewNews, 
	nntpArticleByNumber, nntpArticleByID, nntpBodyByID, nntpBodyByNumber, nntpHeadByID, nntpHeadByNumber, 
	nntpStatByID, nntpStatByNumber, nntpNext, nntpLast, nntpQuit, nntpAbort, nntpXOver, nntpListOverViewFmt, 
	nntpDate, nntpAuthenticate, nntpXHdr };

typedef void __fastcall (__closure *TRequestDone)(System::TObject* Sender, TNntpRequest RqType, Word 
	Error);

class __declspec(delphiclass) NntpException;
class __declspec(pascalimplementation) NntpException : public Sysutils::Exception
{
	typedef Sysutils::Exception inherited;
	
public:
	/* Exception.Create */ __fastcall NntpException(const System::AnsiString Msg) : Sysutils::Exception(
		Msg) { }
	/* Exception.CreateFmt */ __fastcall NntpException(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size) : Sysutils::Exception(Msg, Args, Args_Size) { }
	/* Exception.CreateRes */ __fastcall NntpException(int Ident) : Sysutils::Exception(Ident) { }
	/* Exception.CreateResFmt */ __fastcall NntpException(int Ident, const System::TVarRec * Args, const 
		int Args_Size) : Sysutils::Exception(Ident, Args, Args_Size) { }
	/* Exception.CreateHelp */ __fastcall NntpException(const System::AnsiString Msg, int AHelpContext)
		 : Sysutils::Exception(Msg, AHelpContext) { }
	/* Exception.CreateFmtHelp */ __fastcall NntpException(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size, int AHelpContext) : Sysutils::Exception(Msg, Args, Args_Size, AHelpContext
		) { }
	/* Exception.CreateResHelp */ __fastcall NntpException(int Ident, int AHelpContext) : Sysutils::Exception(
		Ident, AHelpContext) { }
	/* Exception.CreateResFmtHelp */ __fastcall NntpException(int Ident, const System::TVarRec * Args, 
		const int Args_Size, int AHelpContext) : Sysutils::Exception(Ident, Args, Args_Size, AHelpContext)
		 { }
	
public:
	/* TObject.Destroy */ __fastcall virtual ~NntpException(void) { }
	
};

class __declspec(delphiclass) TNntpCli;
class __declspec(pascalimplementation) TNntpCli : public Classes::TComponent
{
	typedef Classes::TComponent inherited;
	
__published:
	__fastcall virtual TNntpCli(Classes::TComponent* AOwner);
	__fastcall virtual ~TNntpCli(void);
	virtual void __fastcall Connect(void);
	virtual void __fastcall Abort(void);
	virtual void __fastcall Quit(void);
	virtual void __fastcall Group( System::AnsiString NewsGroupName);
	virtual void __fastcall ArticleByNumber(int Number, Classes::TStream* DestStream);
	virtual void __fastcall ArticleByID( System::AnsiString ID, Classes::TStream* DestStream);
	virtual void __fastcall HeadByNumber(int Number, Classes::TStream* DestStream);
	virtual void __fastcall HeadByID( System::AnsiString ID, Classes::TStream* DestStream);
	virtual void __fastcall BodyByNumber(int Number, Classes::TStream* DestStream);
	virtual void __fastcall BodyByID( System::AnsiString ID, Classes::TStream* DestStream);
	virtual void __fastcall StatByNumber(int Number);
	virtual void __fastcall StatByID( System::AnsiString ID);
	virtual void __fastcall Next(void);
	virtual void __fastcall Last(void);
	virtual void __fastcall List(Classes::TStream* DestStream);
	virtual void __fastcall Post(Classes::TStream* FromStream);
	virtual void __fastcall Help(Classes::TStream* DestStream);
	virtual void __fastcall XHdr( System::AnsiString Header,  System::AnsiString Range, Classes::TStream* 
		DestStream);
	virtual void __fastcall Authenticate(void);
	virtual void __fastcall XOver( System::AnsiString Articles, Classes::TStream* DestStream);
	virtual void __fastcall ListOverViewFmt(Classes::TStream* DestStream);
	virtual void __fastcall Date(void);
	virtual void __fastcall NewGroups(System::TDateTime When, bool GMTFLag,  System::AnsiString Distributions
		, Classes::TStream* DestStream);
	virtual void __fastcall NewNews(System::TDateTime When, bool GMTFLag,  System::AnsiString NewsGroupName
		,  System::AnsiString Distributions, Classes::TStream* DestStream);
	
protected:
	HWND FWindowHandle;
	System::AnsiString FHost;
	TNntpState FState;
	Wsocket::TWSocket* FWSocket;
	System::AnsiString FRequest;
	TNntpRequest FRequestType;
	bool FRequestDoneFlag;
	bool FSentFlag;
	int FStatusCode;
	char FSendBuffer[4096];
	char FReceiveBuffer[4096];
	int FReceiveLen;
	System::AnsiString FLastResponse;
	System::AnsiString FLastCmdResponse;
	System::AnsiString FErrorMessage;
	int FArticleEstimated;
	int FArticleFirst;
	int FArticleLast;
	int FArticleNumber;
	System::AnsiString FArticleID;
	System::TDateTime FServerDate;
	Classes::TStream* FDataStream;
	System::AnsiString FUserName;
	System::AnsiString FPassWord;
	void __fastcall (__closure *FNext)(void);
	bool FPostingPermited;
	Wsocket::TSessionConnected FOnSessionConnected;
	Wsocket::TSessionClosed FOnSessionClosed;
	Wsocket::TDataAvailable FOnDataAvailable;
	TRequestDone FOnRequestDone;
	TNntpDisplay FOnDisplay;
	Classes::TNotifyEvent FOnMessageBegin;
	Classes::TNotifyEvent FOnMessageEnd;
	Classes::TNotifyEvent FOnMessageLine;
	Classes::TNotifyEvent FOnStateChange;
	void __fastcall WndProc(Messages::TMessage &MsgRec);
	MESSAGE void __fastcall WMNntpRequestDone(Messages::TMessage &msg);
	void __fastcall WSocketDnsLookupDone(System::TObject* Sender, Word Error);
	void __fastcall WSocketSessionConnected(System::TObject* Sender, Word Error);
	void __fastcall WSocketDataAvailable(System::TObject* Sender, Word Error);
	void __fastcall WSocketSessionClosed(System::TObject* Sender, Word Error);
	void __fastcall WSocketDataSent(System::TObject* Sender, Word Error);
	virtual void __fastcall TriggerRequestDone(Word Error);
	virtual void __fastcall TriggerStateChange(void);
	virtual void __fastcall StateChange(TNntpState NewState);
	virtual void __fastcall SendRequest(void);
	virtual void __fastcall GroupNext(void);
	virtual void __fastcall QuitNext(void);
	virtual void __fastcall GetArticleNext(void);
	virtual void __fastcall GetArticleLineNext(void);
	virtual void __fastcall GetArticleByNumber(TNntpRequest RqType, int Number, Classes::TStream* DestStream
		);
	virtual void __fastcall GetArticleByID(TNntpRequest RqType,  System::AnsiString ID, Classes::TStream* 
		DestStream);
	virtual void __fastcall GetArticle(TNntpRequest RqType,  System::AnsiString ID, Classes::TStream* DestStream
		);
	virtual void __fastcall PostNext(void);
	virtual void __fastcall PostDone(void);
	virtual void __fastcall PostBlock(void);
	virtual void __fastcall PostSendNext(void);
	virtual void __fastcall DateNext(void);
	virtual void __fastcall AuthenticateNext1(void);
	virtual void __fastcall AuthenticateNext2(void);
	__property HWND Handle = {read=FWindowHandle, nodefault};
	
__published:
	__property Wsocket::TWSocket* WSocket = {read=FWSocket, nodefault};
	__property TNntpState State = {read=FState, nodefault};
	__property System::AnsiString Host = {read=FHost, write=FHost, nodefault};
	__property System::AnsiString ErrorMessage = {read=FErrorMessage, nodefault};
	__property System::AnsiString LastResponse = {read=FLastResponse, nodefault};
	__property int StatusCode = {read=FStatusCode, nodefault};
	__property bool PostingPermited = {read=FPostingPermited, nodefault};
	__property int ArticleEstimated = {read=FArticleEstimated, nodefault};
	__property int ArticleFirst = {read=FArticleFirst, nodefault};
	__property int ArticleLast = {read=FArticleLast, nodefault};
	__property int ArticleNumber = {read=FArticleNumber, nodefault};
	__property System::AnsiString ArticleID = {read=FArticleID, nodefault};
	__property System::TDateTime ServerDate = {read=FServerDate};
	__property System::AnsiString UserName = {read=FUserName, write=FUserName, nodefault};
	__property System::AnsiString PassWord = {read=FPassWord, write=FPassWord, nodefault};
	__property Wsocket::TSessionConnected OnSessionConnected = {read=FOnSessionConnected, write=FOnSessionConnected
		};
	__property Wsocket::TSessionClosed OnSessionClosed = {read=FOnSessionClosed, write=FOnSessionClosed
		};
	__property Wsocket::TDataAvailable OnDataAvailable = {read=FOnDataAvailable, write=FOnDataAvailable
		};
	__property TRequestDone OnRequestDone = {read=FOnRequestDone, write=FOnRequestDone};
	__property TNntpDisplay OnDisplay = {read=FOnDisplay, write=FOnDisplay};
	__property Classes::TNotifyEvent OnMessageBegin = {read=FOnMessageBegin, write=FOnMessageBegin};
	__property Classes::TNotifyEvent OnMessageEnd = {read=FOnMessageEnd, write=FOnMessageEnd};
	__property Classes::TNotifyEvent OnMessageLine = {read=FOnMessageLine, write=FOnMessageLine};
	__property Classes::TNotifyEvent OnStateChange = {read=FOnStateChange, write=FOnStateChange};
};

//-- var, const, procedure ---------------------------------------------------
#define NntpCliVersion (Byte)(105)
extern System::AnsiString CopyRight;
#define NNTP_RCV_BUF_SIZE (Word)(4096)
#define WM_NNTP_REQUEST_DONE (Word)(1025)
extern void __fastcall Register(void);
extern void __fastcall ParseListLine(const System::AnsiString Line,  System::AnsiString &NewsGroupName
	, int &LastArticle, int &FirstArticle, char &PostingFlag);

}	/* namespace Nntpcli */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Nntpcli;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// Nntpcli
